include "Vram.inc"

ext VVram_

VramTop equ Vram

; void ClearScreen();
cseg
ClearScreen_: public ClearScreen_
    push af | push hl | push bc
        ld hl,Vram
        ld bc,VramWidth*VramHeight
        do
            ld (hl),20h | inc hl
            dec bc
            ld a,c | or b
        while nz | wend
    pop bc | pop hl | pop af
ret


; void VVramToVram();
cseg
VVramToVram_: public VVramToVram_
    push af | push hl | push de | push bc | push ix | push iy
        ld ix,VVram_
        ld iy,VramTop
        ld c,WindowHeight/3
        do
            ld b,WindowWidth
            do
                ld l,(ix)
                ld h,(ix+WindowWidth)
                
                ld a,l
                and 0fh
                ld e,a
                ld a,h
                rlca | rlca | rlca | rlca
                and 30h
                or e
                or 0c0h
                ld (iy),a

                ld a,l
                rrca | rrca | rrca | rrca
                and 0fh
                ld e,a
                ld a,h
                and 30h
                or e
                or 0c0h
                ld (iy+1),a

                ld l,(ix+WindowWidth*2)

                ld a,l
                rlca | rlca
                and 3ch
                ld e,a
                ld a,h
                rrca | rrca
                and 03h
                or e
                or 0c0h
                ld (iy+VramRowSize),a

                ld a,l
                rrca | rrca
                and 3ch
                ld e,a
                ld a,h
                rlca | rlca
                and 03h
                or e
                or 0c0h
                ld (iy+VramRowSize+1),a

                inc ix
                inc iy | inc iy
            dwnz
            exx
                ld de,WindowWidth*2
                add ix,de
                ld de,VramRowSize*2-WindowWidth*2
                add iy,de
            exx
            dec c
        while nz | wend

        ; ld b,WindowWidth
        ; do
        ;     ld l,(ix)
            
        ;     ld a,l
        ;     and 0fh
        ;     or 0c0h
        ;     ld (iy),a

        ;     ld a,l
        ;     rrca | rrca | rrca | rrca
        ;     and 0fh
        ;     or 0c0h
        ;     ld (iy+1),a

        ;     inc ix
        ;     inc iy | inc iy
        ; dwnz        
    pop iy | pop ix | pop bc | pop de | pop hl | pop af
ret


; ptr<byte> PrintC(ptr<byte> pVram, byte c);
cseg
PrintC_: public PrintC_
    ld (hl),e | inc hl
ret
